// =============== Klassen-Definition: e_MATRIX  ========================================
// e_MATRIX-Klasse fuer e(i,j)- resp. e(i,j,k)-Matrix
// Indizierung von i,j,k beginnt bei 0 !!!
// e-Matrizen werden spaltenweise gespeichert !!!
// e-Matrix kann fuer epsilon-Tensor mit Faktor multipliziert werden !
// ======================================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// experimentelles Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet
// Der Autor bernimmt keine Haftung fr Unvollstndigkeiten und Maengel der Algorithmen!
// Version:  2023
// Compiler: C++
// ================ Include-Files =======================================================
#include "pch.h"
#include "framework.h"
#include "MATRIXclass.h"
// ---------------------
// #include "e_Matrix.h"
// #include "Matrix.h"
// ============================================================================
// public -> Oeffentliche Mitgliedsfunktionen
// ============================================================================
//
// Konstruktor -> e_MATRIX e(ni,nj,faktor)
// =======================================
e_MATRIX::e_MATRIX(int ni, int nj, double faktor) : MATRIX(ni, nj)
{
	//
	//*** std::cerr<<"e_MATRIX_2D::Konstruktor: Einrichten von e_MATRIX"<<'\n'; 
	//
	if (ni != 2 || nj != 2)
	{
		std::cout << "FEHLER => e_Matrix_2D::Konstruktor: alle Dimensionen muessen = 2 sein !!! " << endl;
		std::cout << "FEHLER => e_Matrix_2D:: ni= " << ni << " nj= " << nj << endl;
	}
	else
	{
		// 2D-Matrix
		this->element(0, 1) =  faktor;
		this->element(1, 0) = -faktor;
	};
};
//-----------------------------------------------------------------------------
//
// Konstruktor -> e_MATRIX e(ni,nj,nk,faktor)
// ==========================================
e_MATRIX::e_MATRIX(int ni, int nj, int nk, double faktor) : MATRIX(ni, nj, nk)
{
	//
	//*** std::cerr<<"e_MATRIX_3D::Konstruktor: Einrichten von e_MATRIX"<<'\n'; 
	//
	if (ni != 3 || nj != 3 || nk != 3)
	{
		std::cout << "FEHLER => e_Matrix_3D::Konstruktor: alle Dimensionen muessen = 3 sein !!! " << endl;
		std::cout << "FEHLER => e_Matrix_3D:: ni= " << ni << " nj= " << nj << " nk= " << nk << endl;
	}
	else
	{
		// 3D-Matrix
		this->element(0, 1, 2) =  faktor;
		this->element(1, 2, 0) =  faktor;
		this->element(2, 0, 1) =  faktor;
		this->element(2, 1, 0) = -faktor;
		this->element(1, 0, 2) = -faktor;
		this->element(0, 2, 1) = -faktor;
    };
};//---------------------------------------------------------------------------
//
// Destruktor -> delete &e
// =======================
e_MATRIX::~e_MATRIX(void)
{
//*** std::cerr<<"e_MATRIX::Destruktor: Loeschen von e_MATRIX"<<'\n';
};
// ============================================================================
